;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;        Copyright 2001-2002 The Removers, all rights reserved.
;;         Copying is covered by the GNU General Public License.

;;    This program is free software; you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation; either version 2 of the License, or
;;    (at your option) any later version.

;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;;    GNU General Public License for more details.

***************************************************
* Chargement de programme 68HC11 dans l'mulateur *
***************************************************

	TEXT
load:
; a0 pointe sur le dbut du fichier S1
	move.l	#memory,a1	; mmoire 68hc11
.loop:
	cmp.b	#'S',(a0)+
	bne.s	.end_loop
	cmp.b	#'1',(a0)+
	bne.s	.end_loop
	move.b	(a0)+,d0
	bsr.s	convert_number
	clr.w	d1
	move.b	d0,d1	
	lsl.b	#4,d1
	move.b	(a0)+,d0
	bsr.s	convert_number
	or.b	d0,d1		; nb d'octets  lire
	subq.w	#2,d1
	bls.s	.end_loop
	move.b	(a0)+,d0
	bsr.s	convert_number
	clr.w	d2
	move.b	d0,d2
	lsl.w	#4,d2
	move.b	(a0)+,d0
	bsr.s	convert_number
	or.b	d0,d2
	lsl.w	#4,d2
	move.b	(a0)+,d0
	bsr.s	convert_number
	or.b	d0,d2
	lsl.w	#4,d2
	move.b	(a0)+,d0
	bsr.s	convert_number
	or.b	d0,d2
	and.w	#$ffff,d2
	lea	(a1,d2.l),a2	; adr o stocker
	subq.w	#1,d1
.store_data:
	move.b	(a0)+,d0
	bsr.s	convert_number
	move.b	d0,d3
	lsl.b	#4,d3
	move.b	(a0)+,d0
	bsr.s	convert_number
	or.b	d0,d3
	move.b	d3,(a2)+
	dbf	d1,.store_data
	addq.w	#1,a0		; saute la cloche
	bra.s	.loop
.end_loop:
	rts
	
convert_number:
; input : d0 chiffre hexa en ascii
; output : d0 (valeur de d0 en input)
	cmp.b	#'0',d0
	blo.s	.nan
	cmp.b	#'9',d0
	bhi.s	.nan
	sub.b	#'0',d0
	rts
.nan:
	cmp.b	#'a',d0
	blo.s	.naml
	cmp.b	#'f',d0
	bhi.s	.naml
	sub.b	#'a'-$a,d0
	rts
.naml:
	cmp.b	#'A',d0
	blo.s	.nacl
	cmp.b	#'F',d0
	bhi.s	.nacl
	sub.b	#'A'-$a,d0
	rts
.nacl:
	moveq	#0,d0	; erreur
	rts
	
load_file:
	movem.l	d0-d7/a0-a6,-(sp)
	Fgetdta					; Est-ce que notre
	move.l	d0,old_dta			; fichier existe ???
	Fsetdta	new_dta(pc)
	Fsfirst	nom_fichier(pc),#0
	tst.w	d0
	bne.s	.end_load
	lea	new_dta(pc),a0
	move.l	DTA.length(a0),phys_size
	Malloc	phys_size(pc)
	tst.l	d0
	beq.s	.end_load
	move.l	d0,adr_buffer
	Fopen	nom_fichier(pc),#0
	move.w	d0,handle
	move.l	adr_buffer(pc),a0
	Fread	handle(pc),phys_size(pc),(a0)
	Fclose	handle(pc)
	move.l	adr_buffer(pc),a0
	bsr	load
	Mfree	adr_buffer(pc)
.end_load:
	lea	old_dta(pc),a0
	Fsetdta	(a0)
	movem.l	(sp)+,d0-d7/a0-a6
	rts
	
	BSS
old_dta:
	ds.l	1
new_dta:
	ds.b	44
phys_size:
	ds.l	1
adr_buffer:
	ds.l	1
handle:
	ds.w	1
nom_fichier:
	ds.b	256
