**********************************
* Emulateur-dsassembleur 68HC11 *
**********************************
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;        Copyright 2001-2002 The Removers, all rights reserved.
;;         Copying is covered by the GNU General Public License.

;;    This program is free software; you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation; either version 2 of the License, or
;;    (at your option) any later version.

;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;;    GNU General Public License for more details.

	opt	w-

	include	'gemdos.s'

	output	'dbghc11.tos'

	include	'defines.s'
	include	'vectors.s'

SYSTEM	equ	1

	TEXT
	
main:
	move.l	4(sp),a6
	move.l	12(a6),a5
	add.l	20(a6),a5
	add.l	28(a6),a5
	add.l	#$100+$400,a5
	move.l	a5,d1
	and.w	#$fffe,d1
	add.l	a6,d1
	move.l	d1,sp
	Mshrink	a6,a5

	lea	$80(a6),a6

	tst.b	(a6)
	beq.s	.no_filename
	clr.w	d0
	move.b	(a6)+,d0
.take_name:
	move.l	#nom_fichier,a5
	subq.w	#1,d0
.copy_name:
	move.b	(a6)+,(a5)+	
	dbf	d0,.copy_name
	clr.b	(a5)+
	bsr	load_file
.no_filename:
;	lea	prog_68hc11(pc),a0
;	bsr	load
	bsr.s	init_hc11

	bsr	aff_init
	bsr	init_windows
	move.l	#this_info,a0
	bsr	prompt_line
	
	clr.l	logical_time

	clr.w	exit_flag

	move.l	#interface,a0
	bsr	interface_redraw
von_neumann:
	bsr.s	get_key
	bsr.s	event_manager
	tst.w	exit_flag
	bne.s	.exit
	tst.w	redraw_flag
	beq.s	.no_redraw
	clr.w	redraw_flag
	move.l	#interface,a0
	bsr	interface_redraw
.no_redraw:
	bra.s	von_neumann
.exit:
	Pterm0

init_hc11:
	move.l	#memory,a0
	move.b	#%00000001,$1000+INIT(a0)	; on mappe la mmoire
	move.b	#$80|$20,$1000+SCSR(a0)		; on peut mettre/recevoir

	move.l	#_RESET,d0
	move.w	(a0,d0.l),_pc	
	
;	move.w	#$03ff,_sp
	rts

	BSS
exit_flag:
	ds.w	1
redraw_flag:
	ds.w	1
exec_flag:
	ds.w	1
	
	TEXT
get_key:
	IFNE	SYSTEM
.wait_key:
	Cconis
	tst.w	d0
	beq.s	.empty_buffer
	Crawcin
	bra.s	.wait_key
.empty_buffer:
	Crawcin
	swap	d0
	ELSE
.wait_key:
	btst.b	#1,$fffffc00.w
	beq.s	.empty_buffer
	move.b	$fffffc02.w,d0
	bra.s	.wait_key
.empty_buffer:
	move.b	$fffffc02.w,d0
	ENDIF
	rts

event_manager:
; d0.w : touches spciales|scan code
	move.l	#.event_table,a0
*	swap	d0
	and.w	#$0fff,d0
.event_loop
	tst.b	1(a0)
	beq.s	.end_manager
	move.b	(a0)+,d1
	beq.s	.no_special_key
.special_key:
	rol.w	#8,d0
	cmp.b	d1,d0
	bne.s	.not_event
	rol.w	#8,d0
	cmp.b	(a0)+,d0
	beq.s	.handle_event
	addq.w	#4,a0
	bra.s	.event_loop
.not_event:
	rol.w	#8,d0
	addq.w	#5,a0
	bra.s	.event_loop
.no_special_key:
	cmp.b	(a0)+,d0
	beq.s	.handle_event
	addq.w	#4,a0
	bra.s	.event_loop
.handle_event:
	move.l	(a0)+,a0
	jsr	(a0)
.end_manager:
	rts
.event_table:
	dc.b	%00000000,$f	; [TAB]
	dc.l	chg_active_window
	dc.b	%00000000,$2e	; C
	dc.l	quit
	dc.b	%00000000,$11	; Z
	dc.l	trace
	dc.b	%00000000,$1f	; S
	dc.l	skip
	dc.b	%00000000,$10	; A
	dc.l	trace_next
	dc.b	%00000000,$1e	; Q
	dc.l	set_adress
	dc.b	%00000000,$4d	; flche droite
	dc.l	right
	dc.b	%00000000,$4b	; flche gauche
	dc.l	left
	dc.b	%00000000,$24	; J
	dc.l	jump_to
	dc.b	%00000000,$26	; L
	dc.l	load_exe_file
	dc.b	%00000000,$50	; Flche bas
	dc.l	down
	dc.b	%00000000,$48	; Flche haut
	dc.l	up
	dc.b	0,0
	even
	
chg_active_window:
	clr.w	redraw_flag
	move.l	#interface,a0
	bsr	switch_active_window
	rts

trace:
	move.w	#$ffff,redraw_flag
	move.w	#$ffff,exec_flag
	bsr	cycle
	rts	

trace_next:
	move.w	#$ffff,redraw_flag
	move.w	_pc,-(sp)
	clr.w	exec_flag
	bsr	cycle
	move.w	_pc,d0
	move.w	(sp)+,_pc
	move.w	d0,-(sp)
.loop:
	move.w	#$ffff,exec_flag
	bsr	cycle
	move.w	(sp),d0
	cmp.w	_pc,d0
	bne.s	.loop
	addq.w	#2,sp
	rts

skip:
	move.w	#$ffff,redraw_flag
	clr.w	exec_flag
	bsr	cycle
	rts	
	
jump_to:
	move.l	#edit_jump,a0
	bsr	prompt_line
	move.l	prompt.text(a0),a0
	bsr	to_num
	move.w	d0,_pc
	move.w	#$ffff,redraw_flag
	rts
	
set_adress:
	move.l	#edit_adress,a0
	bsr	prompt_line
	move.l	prompt.text(a0),a0
	bsr	to_num
	move.w	d0,d6
	move.l	#interface,a0
	bsr	get_active_window
	tst.l	d0
	beq.s	.error
	tst.l	window.user_reserved(a0)
	beq.s	.error
	move.l	window.user_reserved(a0),a0
	move.w	d6,(a0)
	move.w	#$ffff,redraw_flag
.error:
	rts

left:
	move.l	#interface,a0
	bsr	get_active_window
	tst.l	d0
	beq.s	.error
	tst.l	window.user_reserved(a0)
	beq.s	.error
	move.l	window.user_reserved(a0),a0
	subq.w	#1,(a0)
	move.w	#$ffff,redraw_flag
.error:
	rts
	
right:
	move.l	#interface,a0
	bsr	get_active_window
	tst.l	d0
	beq.s	.error
	tst.l	window.user_reserved(a0)
	beq.s	.error
	move.l	window.user_reserved(a0),a0
	addq.w	#1,(a0)
	move.w	#$ffff,redraw_flag
.error:
	rts
	
down:
	move.l	#interface,a0
	bsr	get_active_window
	tst.l	d0
	beq.s	.error
	tst.l	window.user_reserved(a0)
	beq.s	.error
	move.l	window.user_reserved(a0),a2
	move.l	window.redraw(a0),a1
	cmp.l	#aff_dump,a1
	beq.s	.mem_dump
	cmp.l	#disassemble,a1
	bne.s	.error
.disassemble:
	move.w	_pc,-(sp)
	move.l	a2,-(sp)
	move.w	(a2),_pc
	clr.w	exec_flag
	bsr	cycle
	move.l	(sp)+,a2
	move.w	_pc,(a2)
	move.w	(sp)+,_pc	
	move.w	#$ffff,redraw_flag
	rts
.mem_dump:
	moveq	#0,d6
	move.w	window.down_x(a0),d6
	sub.w	window.up_x(a0),d6
	subq.w	#2,d6
	ble.s	.end_dump
	subq.w	#6,d6		; 6 caractres pour crire l'adresse
	ble.s	.end_dump
	divu.w	#3,d6		; 3 caractres par octets
	add.w	d6,(a2)
	move.w	#$ffff,redraw_flag
.end_dump:
.error:
	rts

up:
	move.l	#interface,a0
	bsr	get_active_window
	tst.l	d0
	beq	.error
	tst.l	window.user_reserved(a0)
	beq	.error
	move.l	window.user_reserved(a0),a2
	move.l	window.redraw(a0),a1
	cmp.l	#aff_dump,a1
	beq.s	.mem_dump
	cmp.l	#disassemble,a1
	bne	.error
.disassemble:
; il est difficile de retrouver l'instruction prcdente !!
; on teste sur les 5 octets prcdents
; si on ne trouve pas, on remonte d'un octet
	move.w	_pc,-(sp)
	moveq	#5,d0
.loop:
	move.l	a2,-(sp)
	move.w	(a2),_pc
	move.w	d0,-(sp)
	moveq	#6,d1
	sub.w	d0,d1
	sub.w	d1,_pc
	clr.w	exec_flag
	bsr	cycle
	move.w	(sp)+,d0
	move.l	(sp)+,a2
	move.w	_pc,d1
	cmp.w	(a2),d1
	beq.s	.found
	dbf	d0,.loop
	move.w	(sp)+,_pc
	subq.w	#1,(a2)
	move.w	#$ffff,redraw_flag
	rts
.found:
	move.w	(sp)+,_pc
	moveq	#6,d1
	sub.w	d0,d1
	sub.w	d1,(a2)
	move.w	#$ffff,redraw_flag
	rts
.mem_dump:
	moveq	#0,d6
	move.w	window.down_x(a0),d6
	sub.w	window.up_x(a0),d6
	subq.w	#2,d6
	ble.s	.end_dump
	subq.w	#6,d6		; 6 caractres pour crire l'adresse
	ble.s	.end_dump
	divu.w	#3,d6		; 3 caractres par octets
	sub.w	d6,(a2)
	move.w	#$ffff,redraw_flag
.end_dump:
.error:
	rts

	
load_exe_file:
	move.l	#edit_name,a0
	bsr	prompt_line
	bsr	load_file
	bsr	init_hc11
	move.w	#$ffff,redraw_flag
	rts

quit:
	not.w	exit_flag
	rts

init_windows:
	move.l	#win_trace,a0
	clr.l	window.user_reserved(a0)
	move.l	#win_reg,a0
	clr.l	window.user_reserved(a0)
	move.l	#win_dis,a0
	move.l	#adr_disassembly,window.user_reserved(a0)
	move.l	#win_mem1,a0
	move.l	#adr_memory1,window.user_reserved(a0)
	move.l	#win_mem2,a0
	move.l	#adr_memory2,window.user_reserved(a0)
	rts

	BSS
adr_disassembly:
	ds.w	1
adr_memory1:
	ds.w	1
adr_memory2:
	ds.w	1
	TEXT
	
disassemble:
; a0 : la fentre
	move.w	#1,window.column(a0)
	move.w	#1,window.line(a0)
	move.w	_pc,-(sp)		; sauve le PC actuel
	move.l	a0,-(sp)
	move.w	window.down_y(a0),d7
	sub.w	window.up_y(a0),d7
	subq.w	#1,d7
	blo.s	.end_disassemble
; d7 : nb d'instructions  dsassembler
	tst.l	window.user_reserved(a0)
	beq.s	.from_pc
	move.l	window.user_reserved(a0),a1
	move.w	(a1),_pc
.from_pc:
	subq.w	#1,d7
	blo.s	.end_disassemble
.disassemble:
	move.w	d7,-(sp)
	move.w	_pc,-(sp)
	bsr	fetch
	tst.l	d0
	beq.s	.not_an_instruction
	move.l	d0,a0
	bsr	decode
	bra.s	.loop
.not_an_instruction:
	bsr	data
.loop:
	move.w	(sp)+,d0
	move.l	2(sp),a0
	bsr	aff_mnemo
	move.w	(sp)+,d7
	dbf	d7,.disassemble
.end_disassemble:
	move.l	(sp)+,a0
	move.w	(sp)+,_pc
	rts

************
* Un cycle *
************
cycle:
	bsr.s	reinit_mnemo
	bsr	fetch	; PC incrment par effets de bord
	tst.l	d0	; instruction reconnue ?
	beq.s	.cycle_error	; non -> erreur
	move.l	d0,a0
	bsr.s	decode
	tst.w	exec_flag
	beq.s	.no_exec
	bsr	execute
.no_exec:
	clr.w	exec_flag
	moveq	#-1,d0
	rts
.cycle_error:
	bsr	data
	clr.w	exec_flag
	moveq	#0,d0
	rts	

reinit_mnemo:
	clr.l	text
	clr.l	code
	clr.l	dir
	clr.l	ext
	clr.l	imm_e
	clr.l	imm_s
	clr.l	ind_x
	clr.l	ind_y
	clr.l	mask
	clr.l	rel
	rts
	
decode:
; a0 : adresse de la routine finissant le dcodage de l'instruction
	move.l	#memory,a1
	move.l	#$10000,d1		; copie le dbut de la mmoire
	lea	(a1,d1.l),a2		; du 68hc11  la fin (circularit)
	move.l	(a1),(a2)		; 2 mots longs devraient suffire
	move.l	4(a1),4(a2)		; vu la taille des instructions
	clr.l	d1
	move.w	_pc,d1
	lea	(a1,d1.l),a1	; se positionne sur le reste du code
	bsr.s	reinit_mnemo
	jsr	(a0)	; PC incrment par effets de bord
	rts

execute:
	move.l	code,a0
	move.l	#memory,a1	; excution (on suppose tous les
	jsr	(a0)		; champs remplis correctement)
	bsr.s	count_cycles	; on compte les cycles
	rts

count_cycles:
	moveq	#0,d0
	move.w	nb_cycles,d0
	add.l	d0,logical_time
	rts
	
fetch:
	move.l	#memory,a0
	clr.l	d0
	move.w	_pc,d0
	lea	(a0,d0.l),a0
	move.l	#translation_table,a1
	moveq	#0,d0
.op:
	lea	(a0),a2
	lea	(a1),a3
	clr.w	d1
	move.b	(a3)+,d1
	beq.s	.no_op
	move.w	d1,d2
	move.w	d1,d3
	addq.b	#2,d2	; 1 pour n et 1 pour l'arrondi
	and.w	#%11111110,d2
	addq.b	#6,d2
	lea	(a1,d2.w),a1
	subq.b	#1,d1
.cmp:
	cmp.b	(a3)+,(a2)+
	dbne	d1,.cmp
	bne.s	.op
	move.l	-6(a1),d0
	move.w	-2(a1),nb_cycles
	add.w	d3,_pc
	rts
.no_op:
	rts

data:
	move.l	#memory,a1
	clr.l	d1
	move.w	_pc,d1
	lea	(a1,d1.l),a1	; se positionne sur le reste du code
	clr.l	text
	clr.l	code
	clr.l	dir
	clr.l	ext
	clr.l	imm_e
	clr.l	imm_s
	clr.l	ind_x
	clr.l	ind_y
	clr.l	mask
	clr.l	rel
	move.l	#.data_txt,text
	move.l	a1,dir
	addq.w	#1,_pc
	rts
.data_txt:
	asciiz	'DCB'
	even

	include	'load.s'

	include	'aff.s'
	
	DATA
;prog_68hc11:
*	incbin	'.\club.nik\prg_lh~1\chenil.s10'
*	incbin	'.\club.nik\prg_lh~1\chenil.s1'	
*	incbin	'.\club.nik\prg_lh~1\prog_68h.s10'
*	incbin	'.\club.nik\progra~2\echo.s1'
*	incbin	'.\club.nik\progra~1\prog_2~1.s1'
*	incbin	'.\vivian\angles.s1'
*	incbin	'.\test.s1'
*	incbin	'.\balisest.s1'
	
	DATA
start:
	dc.b	27,'E'
	dc.b	'68HC11 Emulator',13,11
	dc.b	'by Seb/The Removers',13,11,0
end:
	dc.b	13,'Emulation done',13,11,0
	even
	
	BSS
nb_cycles:
	ds.w	1
text:
	ds.l	1
code:
	ds.l	1
dir:
	ds.l	1
ext:
	ds.l	1
imm_e:
	ds.l	1
imm_s:
	ds.l	1
ind_x:
	ds.l	1
ind_y:
	ds.l	1
mask:
	ds.l	1
rel:
	ds.l	1
logical_time:
	ds.l	1
operandes:
	ds.b	256
	even
	
	include	'iset_cod.s'
	include	'iset_dat.s'
	include	'register.s'

	include	'string.s'
	
