;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;        Copyright 2001-2002 The Removers, all rights reserved.
;;         Copying is covered by the GNU General Public License.

;;    This program is free software; you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation; either version 2 of the License, or
;;    (at your option) any later version.

;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;;    GNU General Public License for more details.

; Window Manager
; (en fait, console amliore)

LINE_SIZE:	equ	80

COL_MAX:	equ	80
ROW_MAX:	equ	25

TAB_MASK:	equ	%111

DrawChar	macro
; argument 1 : adresse de la fin du caractre dans la fonte
; argument 2 : adresse dans l'cran
;  la fin : argument 1 au dbut du caractre dans la fonte
; argument 2 pointe sur le caractre  droite suivant dans l'cran (s'il existe)
	move.b	-(\1),15*LINE_SIZE(\2)
	move.b	-(\1),14*LINE_SIZE(\2)
	move.b	-(\1),13*LINE_SIZE(\2)
	move.b	-(\1),12*LINE_SIZE(\2)
	move.b	-(\1),11*LINE_SIZE(\2)
	move.b	-(\1),10*LINE_SIZE(\2)
	move.b	-(\1),9*LINE_SIZE(\2)
	move.b	-(\1),8*LINE_SIZE(\2)
	move.b	-(\1),7*LINE_SIZE(\2)
	move.b	-(\1),6*LINE_SIZE(\2)
	move.b	-(\1),5*LINE_SIZE(\2)
	move.b	-(\1),4*LINE_SIZE(\2)
	move.b	-(\1),3*LINE_SIZE(\2)
	move.b	-(\1),2*LINE_SIZE(\2)
	move.b	-(\1),1*LINE_SIZE(\2)
	move.b	-(\1),(\2)+
	endm	

ClearChar	macro
; efface le caractre
; paramtre 1 : adresse  l'cran (incrmente)
	clr.b	15*LINE_SIZE(\1)
	clr.b	14*LINE_SIZE(\1)
	clr.b	13*LINE_SIZE(\1)
	clr.b	12*LINE_SIZE(\1)
	clr.b	11*LINE_SIZE(\1)
	clr.b	10*LINE_SIZE(\1)
	clr.b	9*LINE_SIZE(\1)
	clr.b	8*LINE_SIZE(\1)
	clr.b	7*LINE_SIZE(\1)
	clr.b	6*LINE_SIZE(\1)
	clr.b	5*LINE_SIZE(\1)
	clr.b	4*LINE_SIZE(\1)
	clr.b	3*LINE_SIZE(\1)
	clr.b	2*LINE_SIZE(\1)
	clr.b	1*LINE_SIZE(\1)
	clr.b	(\1)+
	endm

CopyChar	macro
; paramtre 1 : adresse  l'cran du caractre  copier (incrmente)
; paramtre 2 : adresse o copier (incrmente)
	move.b	15*LINE_SIZE(\1),15*LINE_SIZE(\2)
	move.b	14*LINE_SIZE(\1),14*LINE_SIZE(\2)
	move.b	13*LINE_SIZE(\1),13*LINE_SIZE(\2)
	move.b	12*LINE_SIZE(\1),12*LINE_SIZE(\2)
	move.b	11*LINE_SIZE(\1),11*LINE_SIZE(\2)
	move.b	10*LINE_SIZE(\1),10*LINE_SIZE(\2)
	move.b	9*LINE_SIZE(\1),9*LINE_SIZE(\2)
	move.b	8*LINE_SIZE(\1),8*LINE_SIZE(\2)
	move.b	7*LINE_SIZE(\1),7*LINE_SIZE(\2)
	move.b	6*LINE_SIZE(\1),6*LINE_SIZE(\2)
	move.b	5*LINE_SIZE(\1),5*LINE_SIZE(\2)
	move.b	4*LINE_SIZE(\1),4*LINE_SIZE(\2)
	move.b	3*LINE_SIZE(\1),3*LINE_SIZE(\2)
	move.b	2*LINE_SIZE(\1),2*LINE_SIZE(\2)
	move.b	1*LINE_SIZE(\1),1*LINE_SIZE(\2)	
	move.b	(\1)+,(\2)+
	endm

	TEXT
init_vt52:
	pea	.init_string(pc)
	move.w	#9,-(sp)
	trap	#1
	addq.w	#6,sp
	rts
.init_string:
	dc.b	27,'E',27,'f',0
	even
	
manager_init:
; initialisation du manager
; beaucoup de registres modifis
; calcul de la fonte en inverse vido
	bsr.s	init_vt52
	move.l	#fonte,a0
	move.l	#fonte_inverse,a1
	move.w	#256-1,d0
.inverse_char:
	REPT	4
	move.l	(a0)+,d1
	not.l	d1
	move.l	d1,(a1)+	
	ENDR
	dbf	d0,.inverse_char
; om met par dfaut la fonte normale comme fonte utilise
	bsr	inverse_off
; curseur li
	bsr	autolock_on
; par dfaut on travaille sur un cran de COL_MAX colonnes et ROW_MAX lignes
	bsr	set_default_clipping
; par dfaut, on n'enroule pas
	bsr	wrap_off
; par dfaut, la zone de clipping ne scrolle pas
	bsr	scroll_off
; par dfaut, on n'efface pas les fins de ligne
	bsr	clear_off
; par dfaut, on n'interprte pas les codes de controle
	bsr	control_off
	IFNE	0
; par dfaut, tabulations relatives
	bsr	relative_on
	ENDIF
; cran = cran physique
	move.w	#2,-(sp)
	trap	#14
	addq.w	#2,sp
	move.l	d0,adr_screen
	bsr	clear_zone
	rts

set_default_clipping:
	move.w	#0,d0
	move.w	#0,d1
	move.w	#COL_MAX,d2
	move.w	#ROW_MAX,d3
set_clipping_rect:
; attention, les coordonnes donnes doivent tre valides
; c'est  dire bien ordonnes et infrieures aux bornes
; TODO : vrifier
; d0,d1 : coin infrieur gauche
; d2,d3 : coin suprieur droit
	cmp.w	d0,d2
	bhs.s	.col_ok
	exg.l	d0,d2
.col_ok:
	cmp.w	d1,d3
	bhs.s	.row_ok
	exg.l	d1,d3
.row_ok
	move.w	d0,col_min
	move.w	d1,row_min
	move.w	d2,col_max
	move.w	d3,row_max
	tst.w	autolock_flag
	beq.s	.unlock
.lock:
	bra.s	move_curseur
.unlock:
	rts

move_curseur:
; d0,d1 : nouvelles coordonnes
	move.w	d0,curseur_col
	move.w	d1,curseur_row
	rts
	
get_curseur:
; renvoie dans d0,d1 les coordonnes du curseur
	move.w	curseur_col,d0
	move.w	curseur_row,d1
	rts
	
inverse_on:
; passe en mode inverse vido
	move.l	#fonte_inverse,adr_fonte
	rts

inverse_off:
; passe en mode normal
	move.l	#fonte,adr_fonte
	rts
	
autolock_on:
; curseur li  la zone de clipping
	move.w	#$ffff,autolock_flag
	rts
	
autolock_off:
; curseur libre
	clr.w	autolock_flag
	rts
	
wrap_on:
; enroulement des lignes
	move.w	#$ffff,wrap_flag
	rts
	
wrap_off:
; non enroulement des lignes
	clr.w	wrap_flag
	rts

scroll_on:
; scrolling de la zone de clipping
	move.w	#$ffff,scroll_flag
	rts

scroll_off:
; non scrolling
	clr.w	scroll_flag
	rts

clear_on:
; effacement automatique des fins de ligne (criture de chaines)
	move.w	#$ffff,clear_flag
	rts
	
clear_off:
; non effacement
	clr.w	clear_flag
	rts

control_on:
; caractres de controle
	move.w	#$ffff,control_flag
	rts

control_off:
; texte brut
	clr.w	control_flag
	rts
	
	IFNE	0
relative_on:
; tabulations relatives
	move.w	#$ffff,relative_flag
	rts	
	
relative_off:
; tabulations absolues
	clr.w	relative_flag
	rts
	ENDIF
	
putchar:
; d0 : caractre  crire
	movem.w	clip_rect,d1-d4
	moveq	#0,d5		; efface le poids fort
	move.w	curseur_col,d5
	move.w	curseur_row,d6
	cmp.w	d5,d1
	bhi.s	.no_putchar
	cmp.w	d6,d2
	bhi.s	.no_putchar
	cmp.w	d5,d3
	bls.s	.no_putchar
	cmp.w	d6,d4
	bhi.s	.putchar
.no_putchar:
	tst.w	control_flag
	bne	.special_com_char
	rts
.putchar:
	move.l	adr_fonte,a0
	move.l	adr_screen,a1
	tst.w	control_flag
	bne.s	.com_char
.raw_char:
	and.w	#$ff,d0	; ne prend que l'octet de poids faible
	lsl.w	#4,d0	; multiplie par 16
	lea	16(a0,d0.w),a2	; adresse dans la fonte
	move.w	d6,d7		; curseur_row
	mulu.w	#16*LINE_SIZE,d7; calcule l'adresse
	add.l	d5,d7
	lea	(a1,d7.l),a3	; adresse  l'cran
	DrawChar	a2,a3
.calc_curseur:
	addq.w	#1,d5		; avance le curseur
	cmp.w	d5,d3
	bhi.s	.curseur_ok
.curseur_not_ok:
	tst.w	wrap_flag	; enroulement ?
	beq.s	.curseur_ok	; non -> ok
	move.w	d1,d5		; revient  la ligne
	addq.w	#1,d6
	cmp.w	d6,d4		; besoin ventuel de scroller
	bls	scroll_zone	
.curseur_ok:
	move.w	d5,curseur_col	
	move.w	d6,curseur_row
	rts
.com_char:
	cmp.b	#13,d0	; retour chariot
	beq	.cr
	cmp.b	#11,d0	; passage  la ligne
	beq	.lf
	cmp.b	#9,d0	; tabulation
	bne	.raw_char
.tab:
	move.w	d6,d7		; curseur_row
	mulu.w	#16*LINE_SIZE,d7; calcule l'adresse
	add.l	d5,d7
	lea	(a1,d7.l),a3	; adresse  l'cran
	IFNE	0
	tst.w	relative_flag
	beq.s	.tab_absolu
	ENDIF
.tab_relatif:
	move.w	d5,d7
	sub.w	d1,d7		; dcalage par rapport au bord de la zone
	add.w	#TAB_MASK,d7
	and.w	#~TAB_MASK,d7
	add.w	d1,d7		; colonne du rsultat
	cmp.w	d7,d3		; dpasse-t-on ?
	bhs.s	.tab_rel_clip
	move.w	d3,d7		; valeur max
.tab_rel_clip:
	move.w	d7,d0
	sub.w	d5,d7		; nb de colonnes  effacer
	ble.s	.no_tab_rel
	subq.w	#1,d7
*	ble.s	.skip_tab_rel
.tab_rel_loop:
	ClearChar	a3
	dbf	d7,.tab_rel_loop
.skip_tab_rel:
	move.w	d0,d5
	cmp.w	d5,d3
	bls	.curseur_not_ok
.no_tab_rel:
	bra	.curseur_ok
	IFNE	0
.tab_absolu:	
	rts
	ENDIF
.cr:
	move.w	d1,curseur_col
	rts
.lf:
	addq.w	#1,d6
	cmp.w	d6,d4
	bls.s	scroll_zone
	move.w	d6,curseur_row
	rts
.special_com_char:
; par spcial s'entend des caractres qui ne font aucune sortie  l'cran
	cmp.b	#13,d0	; retour chariot
	beq	.cr
	cmp.b	#11,d0	; passage  la ligne
	beq	.lf
	rts

scroll_zone:
; d1-d4 = clip rect
; d5,d6 coordonne du curseur
; a0 : adr fonte
; a1 : adr screen
; appel si d4=d6
; scroll la zone et met  jour les coordonnes du curseur
; aussi bien en registre qu'en mmoire
	tst.w	scroll_flag
	beq	.no_scrolling
.scrolling:
	move.w	d5,curseur_col
	subq.w	#1,d6
	move.w	d6,curseur_row
	movem.l	d0-d7/a0-a6,-(sp)
	sub.w	d1,d3
	ble	.end_scrolling
	sub.w	d2,d4
	ble	.end_scrolling
	subq.w	#1,d3
	move.w	d3,d6
	subq.w	#2,d4			; nb lignes  scroller
	ble	.end_scrolling
	move.w	#16*LINE_SIZE,d5	; offset pour passer  la ligne
	mulu.w	d5,d2
	add.l	d1,d2			; attention, doit tre sur 32 bits
	lea	(a1,d2.l),a2		; adresse o copier
	lea	(a2,d5.w),a3		; adresse source
.scroll_row:
	move.l	a3,a0
	move.l	a2,a1
	add.w	d5,a2
	add.w	d5,a3
	move.w	d6,d3
.scroll_col:
	CopyChar	a0,a1
	dbf	d3,.scroll_col
	dbf	d4,.scroll_row
; effacer la ligne libre
	move.w	d6,d3
	move.l	a2,a1
.clear_col:
	ClearChar	a1
	dbf	d3,.clear_col
.end_scrolling:
	movem.l	(sp)+,d0-d7/a0-a6
	rts
.no_scrolling:
	move.w	d5,curseur_col
	move.w	d6,curseur_row
	rts

clear_zone:
; cls clipp
	movem.w	clip_rect,d1-d4
	move.l	adr_screen,a1
	sub.w	d1,d3
	ble.s	.end_clear
	sub.w	d2,d4
	ble.s	.end_clear
	move.w	#16*LINE_SIZE,d5	; offset pour passer  la ligne
	mulu.w	d5,d2		; calcule de l'adresse
	add.l	d1,d2		; le movem.w tend le signe
	lea	(a1,d2.l),a2	; adresse du premier caractre
	subq.w	#1,d3		; nb de colonnes
	move.w	d3,d6
	subq.w	#1,d4		; nb lignes
.clear_line:
	move.l	a2,a0
	add.w	d5,a2
	move.w	d6,d3
.clear_col:
	ClearChar	a0
	dbf	d3,.clear_col
	dbf	d4,.clear_line
.end_clear:
	move.w	col_min,curseur_col
	move.w	row_min,curseur_row
	rts

clear_line:
; a0 : adr fonte
; a1 : adr screen
; d1-d4 : clip rect
; d5,d6 : coordonnes du curseur
	tst.w	clear_flag
	beq.s	.no_clear
	cmp.w	d6,d3
	bls.s	.no_clear
	move.w	d6,d7
	mulu.w	#16*LINE_SIZE,d7
	add.l	d5,d7		; doit tre sur 32 bits
	lea	(a1,d7.l),a3
	move.w	d3,d7
	sub.w	d5,d7		; nb de colonnes  vider
	ble.s	.no_clear
	subq.w	#1,d7
.clear:
	ClearChar	a3
	dbf	d7,.clear
.no_clear:
	rts

putstring:
; a6=adr chaine au format C
; seul le caractre nul est toujours interprt
; en fait, dans le cas o control_flag==false
; les chaines au format Pascal serait mieux adaptes
* pour l'instant de simples appels  putchar
.putstring:
	move.b	(a6)+,d0
	beq.s	.end_putstring
	bsr	putchar
	bra.s	.putstring
.end_putstring:
	bsr.s	clear_line
	rts
	
	DATA
fonte:
	incbin	'font8x16.dat'

	BSS
; adresse de l'cran (640*400 1 plan)
adr_screen:
	ds.l	1
; Coordonnes du curseur
curseur:
curseur_col:
	ds.w	1
curseur_row:
	ds.w	1
; Fonte en cours d'utilisation
adr_fonte:
	ds.l	1
; Rectangle de clipping
clip_rect:
col_min:
	ds.w	1
row_min:
	ds.w	1
col_max:
	ds.w	1
row_max:
	ds.w	1
; Enroulement automatique en fin de ligne
wrap_flag:
	ds.w	1
; Scrolling de la zone de clipping si dpassement de zone
scroll_flag:
	ds.w	1
; Mode d'affichage des lignes
clear_flag:
	ds.w	1
; Interprtation des codes de controle
control_flag:
	ds.w	1
	IFNE	0
; Mode de fonctionnement des tabulations
; le mode relatif est le seul justifiable (jusqu' nouvel ordre)
; (en plus, je suis feignant...)
relative_flag:
	ds.w	1
	ENDIF
; Curseur bouge avec le clipping
autolock_flag:
	ds.w	1
	
fonte_inverse:
	REPT	256
	ds.b	16
	ENDR
